/////////////////////////////////////////////////////////////////////////////////////////////
//Epizykoide - Hohe Punktezahl (faktor=10)
//////////////////////////////////////////////////////////////////////////////////
PVector ort;
ArrayList<PVector> punkte;//Spurpunkte
float X,Y,x,y;//Koordinaten der Orte
float r,a,b;
float D; //Punkte-Abstand
float DMax;
int i,j;
int faktor;
float dt;//Schrittweite
int max;
boolean stopp,fertig;
int abschnitte =64;
int grenze = abschnitte+1;
color[] farbAnker;
color[] farben4096;
color[] farben256;
float h1,b1;
float h2,b2;
float S1, S2;
/////////////////////////////////////////////////////////////////
void setup() {
  size(1000, 1000);
  background(255);
  colorMode(HSB,256,256,256,256);
  //Epizykloide:
  a=2; b=2;//Kardioide
  //a=3; b=3;//Nephroide
  //a=20;b=20;
  x=0;y=0;X=0;Y=0;//Initialisierung
  dt = 0; 
  r=400;
  faktor = 10;
  max = faktor*360;
  i=0;
  stopp = false; 
  fertig = false;
  DMax =0;
  ort =new PVector(x,y);       
  punkte = new ArrayList<PVector>();
  
  farben256 = new color[256];
  for(int i=0; i<256;i++){
    farben256[i]=color(i,255,255,255);
  }
  //Farbpalette erzeugen
  farbAnker = new color[grenze];//Initialsierung
  for(int i=0;i<grenze;i++){
     farbAnker[i] = color(0);
  } 
  
  farben4096 = new color[4096];
  for(int i=0;i<4096;i++){
     farben4096[i] = color(0);
  }
  h1=random(256);
  b1=random(180,256);
  farbAnker[0] = color(h1,255,b1);
  for(int j=1; j<grenze; j++){
      farbAnker[j] = farbeBestimmen( farbAnker[j-1]);  
  }
  for(int i=0; i<abschnitte; i++){
    zwischenFarbenBestimmen(i*abschnitte,farbAnker[i],farbAnker[i+1]);
  } 
}
/////////////////////////////////////////////////////////////////////////////////////
void draw() { 
   
    translate(width/2,height/2);//Ursprung in der Bildmitte     
    strokeWeight(1);  stroke(0);
    if(!stopp){  //sw-Bild  
       if(!fertig)background(255);
       for(int i=0; i<max;i=i+2){
         dt = i*PI/180/faktor; 
         x = r*cos(dt);y= r*sin(dt);
         X = r*cos(a*dt);Y= r*sin(b*dt);
         punkte.add(new PVector(x,y));
         punkte.add(new PVector(X,Y));
       } 
       if(!fertig){     
         for(int i =0; i< punkte.size()-1 ;i=i+2){          
           line(punkte.get(i).x,punkte.get(i).y,punkte.get(i+1).x,punkte.get(i+1).y);        
         }             
         fertig=true;
       }
    }else{ //Farbe
      background(0); 
      strokeWeight(2);//gibt bei Faktor 10 gleichmäßigere Farben
      for(int i =0; i< punkte.size()-1 ;i=i+2){           
         /* j=i%256;
         stroke(farben256[j]);*/ //bis maximal a=3,b=3
         //j=i%4096;//Methode: Farbe unabhängig von D
         D = sqrt(sq(punkte.get(i).x-punkte.get(i+1).x)+sq(punkte.get(i).y-punkte.get(i+1).y));
         j=round(5*D)%4096;
         stroke(farben4096[j]);         
         line(punkte.get(i).x,punkte.get(i).y,punkte.get(i+1).x,punkte.get(i+1).y);           
      }        
    }            
}
////////////////////////////////////////////////////////////////////////
color farbeBestimmen(color f){
  color farbe = color(0);//Initialisierung
  h1=hue(f);
  b1=brightness(f);
  h2=random(100,256);
  b2=random(100,256);//Variante
  S1 =abs(h2-h1); 
  S2 =abs(b2-b1);
  while(S1>50 || S1<20 || S2>50){//Steurung der "Abstände" der Ankerfarben
     h2=random(256);
     b2=random(100,256);//Variante
     S1 =abs(h2-h1); 
     S2 =abs(b2-b1);  
  }
  farbe = color(h2,255,b2);//println(h2,b2,S1,S2);
  return farbe;
}

void zwischenFarbenBestimmen(int k, color f1, color f2){
   int start = k;
   for(int i=start; i<64+start;i++){
      farben4096[i] = lerpColor(f1,f2,(float)(i-start)/64);
      farben4096[i] = color( farben4096[i],200);//Transparenz 200
   }
}
/////////////////////////////////////////////////////////////////////////////////

void mousePressed() { 
   println("Rechnung gestartet! Kann einige Minuten dauern. ");
   stopp = true; 
   fertig = false;
}
/////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  
  if(key=='a'){   
     a=a+1; 
     i=0;
     punkte.clear();
     stopp =false;
     fertig = false;
     println("a = "+a+" b = "+b);     
  }
  if(key=='b'){  
     b=b+1; 
     i=0;
     punkte.clear();
     stopp =false;
     fertig = false;
     println("a = "+a+" b = "+b);
  }
  if(key=='c'){     
     println("Rechnung gestartet!");
     a=a+1;  b=b+1; 
     i=0;
     punkte.clear();
     stopp =false;
     fertig = false;
     println("a = "+a+" b = "+b);
  }
  if(key=='+'){      
     faktor = faktor+1;
     max = faktor*360;
     i=0;
     punkte.clear();
     stopp =false;
     fertig = false;
     println("Anzahl Schritte: "+max);
  }
}
/////////////////////////////////////////////////////////////////////////////////////
